#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_RobotsCFG.h"
std::auto_ptr<M_RobotsCFG> M_RobotsCFG::msSingleton(nullptr);

int M_RobotsCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_RobotsCFGData* M_RobotsCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_RobotsCFGData>& M_RobotsCFG::GetMapData()
{
	return mMapData;
}

void M_RobotsCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_RobotsCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_RobotsCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mRankingTyep = element->IntAttribute("RankingTyep");
		{
			const char* Time = element->Attribute("Time");
			std::vector<std::string> vecTime;
			boost::split(vecTime, Time, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecTime.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecTime[i].c_str(), &temp))
				{
					data.mTime.push_back(temp);
				}
			}
		}
		{
			const char* NumberOfRobots = element->Attribute("NumberOfRobots");
			std::vector<std::string> vecNumberOfRobots;
			boost::split(vecNumberOfRobots, NumberOfRobots, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNumberOfRobots.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNumberOfRobots[i].c_str(), &temp))
				{
					data.mNumberOfRobots.push_back(temp);
				}
			}
		}
		data.mMin = element->IntAttribute("Min");
		data.mMax = element->IntAttribute("Max");
		data.mCreateHisCountMin = element->IntAttribute("CreateHisCountMin");
		data.mCreateHisCountMax = element->IntAttribute("CreateHisCountMax");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_RobotsCFG Loaded. Load Data:%u", mMapData.size());
}

void M_RobotsCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_RobotsCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_RobotsCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_RobotsCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "RankingTyep", data.mRankingTyep);
		LuaCfgHelper::readVectorInt(L, "Time", data.mTime);
		LuaCfgHelper::readVectorInt(L, "NumberOfRobots", data.mNumberOfRobots);
		LuaCfgHelper::readInt(L, "Min", data.mMin);
		LuaCfgHelper::readInt(L, "Max", data.mMax);
		LuaCfgHelper::readInt(L, "CreateHisCountMin", data.mCreateHisCountMin);
		LuaCfgHelper::readInt(L, "CreateHisCountMax", data.mCreateHisCountMax);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_RobotsCFG Loaded. Load Data:%u", mMapData.size());
}

void M_RobotsCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_RobotsCFG* M_RobotsCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_RobotsCFG());
	}
	return msSingleton.get();
}

void M_RobotsCFG::Release()
{
	msSingleton.reset(nullptr);
}
